#
# A semi-useful sample widget.
#
# Constructed with coordinates for the starting position of the
# text-box, as well as the text to contain in the box. Redraws 
# itself in "bold" when it obtains focus, and "normal" when it 
# loses it. This is basically just an example of how to create a
# text widget.
#

class ch_box { 
	inherit chwidget

	public method onfocus { } 
	public method unfocus { } 
	public method deleted { }

	public method draw_on_focus { } 
	public method draw_off_focus { } 
	public method draw_deleted { }

	private variable _rpos
	private variable _cpos
	private variable _text

	public method input { ichar } { 

		if { $ichar == "d" } {
			return 1
		}
		
		return 0
	} 

	public constructor { x y text } { } 
}

body ch_box::constructor { x y text } { 
	
	set _rpos $x
	set _cpos $y

	set _text $text

}

body ch_box::draw_on_focus { } { 

	set s [ get_screen ] 

	set oh [ $s get_hedge ] 
	set ov [ $s get_vedge ] 
	set oc [ $s get_corner ] 
	
	$s set_hedge "="
	$s set_vedge "#"
	$s set_corner "*"
	
	$s draw_textbox $_rpos $_cpos $_text

	$s set_hedge $oh
	$s set_vedge $ov
	$s set_corner $oc

	return {}
}

body ch_box::draw_off_focus { } { 

	set s [ get_screen ] 

	$s draw_textbox $_rpos $_cpos $_text

	return {}
}

body ch_box::onfocus { } {

	set s [ get_screen ]
	
	draw_on_focus

}

body ch_box::unfocus { } {
	
	draw_off_focus

}

body ch_box::deleted { } {
	
	draw_deleted 

}

body ch_box::draw_deleted { } { 
	set s [ get_screen ] 

	$s clear_textbox $_rpos $_cpos $_text

	return {}
}

